structure Check :>
sig
    datatype typOrError =
        WellTyped of Syntax.typ
      | IllTyped 
    
    val check : Syntax.exp -> typOrError
        
end  = 
struct

    open Syntax
    
    datatype typOrError =
        WellTyped of Syntax.typ
      | IllTyped 

    type context = (name * typ) list

    (* Given a context gamma and expression e, return
       WellTyped tau if there is a tau such that gamma |- e : tau, or
       IllTyped otherwise *)
    fun checkOpen (gamma : context, e : exp) : typOrError = raise Fail "unimplemented"

    (* Given an expression e, 
       return WellTyped tau if there is a tau such that empty |- e : tau,
       or return IllTyped if e is not well-typed in the empty context *)
    fun check (e : exp) : typOrError = raise Fail "unimplemented"
	
end

